program Himage

  use sep

  implicit none

  integer                              :: n1, n2, i, j, n1s, iter
  real                                 :: o1, d1, o2, d2
  real, dimension(:), allocatable      :: mtrue, m0, dm1, dm2, dm, a1, a2

  call sep_init()

  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2)
  call from_history("o2", o2)
  call from_history("d2", d2)
  call from_param("iter", iter)
  call from_aux("a1","n1", n1s)

  allocate(mtrue(n1*n2), m0(n1*n2), dm1(n1*n2), dm2(n1*n2), dm(n1*n2), a1(n1s), a2(n1s))

  call sep_read(mtrue)
  call sep_read(m0, "m0")
  call sep_read(dm1, "dm1")
  call sep_read(dm2, "dm2")
  call sep_read(a1, "a1")
  call sep_read(a2, "a2")

  dm = a1(iter)*dm1 + a2(iter)*dm2

  call to_history("n1", n1)
  call to_history("o1", o1)
  call to_history("d1", d1)
  call to_history("n2", n2)
  call to_history("o2", o2)
  call to_history("d2", d2)

  call sep_write(dm)

  call sep_close()
end program
